# On InitializeNewViewer

```lua
function yourEvent(user)
    --note  this is similar to OnNewViewer event. The difference is that this event fires before the avatar spawns.
    --also note: under General > Avatar Settings, there's an option to disable "force free avatar" which lets you set everything in shop as gift only
    --which makes this even able to completely handle the first avatar a viewer will get.
     log(user.displayName .. ' is being initialized. you can make changes to them before they spawn!');
end

return function()

    addEvent('selectInitialAvatar', 'yourEvent'); --attaches the event to yourEvent()
    keepAlive();
end
```

{% hint style="info" %}
Events are asynchronous coroutines.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.streamavatars.com/lua-scripting-api/api-reference-and-tips/events/on-initializenewviewer.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
